commit 4772922acd0f7c0725586c72d7efdd9bf6cb1efb
Author: Kroustouris Stauros <staurosk@noc.grnet.gr>
Date:   Fri Jun 26 13:21:26 2015 +0300

    final touches

diff --git a/djnro/templates/edumanage/catenroll.html b/djnro/templates/edumanage/catenroll.html
index e67cabe..3f722a4 100644
--- a/djnro/templates/edumanage/catenroll.html
+++ b/djnro/templates/edumanage/catenroll.html
@@ -2,96 +2,90 @@
 {% load i18n %}
 {% load staticfiles %}
 
-{% block crumbs %}
-<li><a href="{% url manage %}">{% trans "Home" %}</a><span class="divider">/</span></li>
-<li class="active">{% trans "CAT Enroll" %}</li>
-{% endblock %}
-
-{% block extrahead %}
-<script type="text/javascript" src="{% static 'js/jquery.min.js' %}"></script>
-<script src="{% static 'js/bootstrap.min.js' %}"></script>
-{% endblock %}
-
 {% block homeactive %}{% endblock %}
 {% block catactive %}class="active"{% endblock %}
-{% block management_content %}
 
- <h4>eduroam CAT enroll</h4>
+{% block management_content %}
+ <h4>eduroam {% trans 'CAT enroll' %}</h4>
  {% if messages %}
-                    <table class="table table-condensed">
-                        {% for message in messages %}
-                        <tr {% if message.tags %} class="{{ message.tags }}"{% endif %}><td>{{ message }}<td></tr>
-                        {% endfor %}
-                    </table>
-                {% endif %}
+    <table class="table table-condensed">
+        {% for message in messages %}
+        <tr {% if message.tags %} class="{{ message.tags }}"{% endif %}><td>{{ message }}<td></tr>
+        {% endfor %}
+    </table>
+{% endif %}
 <hr>
 {% if current_enrollments %}
 <div class="row">
-<div class="span12">
-	              <table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-bordered" width="100%" id="table">
-					<thead>
-					<tr>
-						<th>{% trans "CAT Institution ID" %}</th>
-						<th>{% trans "CAT configuration profiles" %}</th>
-						<th>{% trans "URL/Status" %}</th>
-						<th>{% trans "CAT instance" %}</th>
-						<th>{% trans "Applier" %}</th>
-					</tr>
-					</thead>
+	<div class="col-md-12">
+		<table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-bordered" width="100%" id="table">
+			<thead>
+				<tr>
+					<th>{% trans "CAT Institution ID" %}</th>
+					<th>{% trans "CAT configuration profiles" %}</th>
+					<th>{% trans "URL/Status" %}</th>
+					<th>{% trans "CAT instance" %}</th>
+					<th>{% trans "Applier" %}</th>
+				</tr>
+			</thead>
 
-					<tbody>
-	                {% for enrollment in current_enrollments %}
-	              	<tr class="GradeC">
-	                	<td>{{enrollment.cat_inst_id}}</td>
-	                	<td>{% if enrollment.cat_configuration_url %}<a href="{{enrollment.cat_configuration_url}}" target="_blank">CAT url</a>{% else %}-{% endif %}</td>
-	                	<td>{% if not enrollment.cat_active %}{% if enrollment.url %}<a href="{{enrollment.url}}" target="_blank">{{enrollment.url|truncatechars:50}}</a>{% else %}-{% endif %}{% else %}ACTIVE{% endif %}</td>
-	                	<td>{{enrollment.cat_instance}}</td>
-	                	<td>{{enrollment.applier.first_name}} {{enrollment.applier.last_name}}</td>
-	                </tr>
-	              	{% endfor %}
-	              	</tbody>
-	              </table>
-	              </div>
-	              </div>
+			<tbody>
+			{% for enrollment in current_enrollments %}
+				<tr class="GradeC">
+					<td>{{enrollment.cat_inst_id}}</td>
+					<td>{% if enrollment.cat_configuration_url %}<a href="{{enrollment.cat_configuration_url}}" target="_blank">CAT url</a>{% else %}-{% endif %}</td>
+					<td>{% if not enrollment.cat_active %}{% if enrollment.url %}<a href="{{enrollment.url}}" target="_blank">{{enrollment.url|truncatechars:50}}</a>{% else %}-{% endif %}{% else %}ACTIVE{% endif %}</td>
+					<td>{{enrollment.cat_instance}}</td>
+					<td>{{enrollment.applier.first_name}} {{enrollment.applier.last_name}}</td>
+				</tr>
+			{% endfor %}
+			</tbody>
+		</table>
+	</div>
+</div>
 {% endif %}
+
 {% if cat_instances %}
 <div class="row">
-<div class="span6 well">
-<form method="POST" class="form-horizontal" id="catenroll_form" action="{% url catenroll %}">
-	{% csrf_token %}
-	<div class="control-group">
-		<label class="control-label" for="id_catinstance"><b>{% trans "CAT instance" %}</b></label>
-		<div class="controls">
-			<select id="catinstance" name="catinstance">
-				{% for instance in cat_instances %}
-				<option value="{{instance.0}}">{{instance.1}}</option>
-				{% endfor %}
-				</select>
-		</div>
-	</div>
-	<div class="control-group">
-		<div class="controls">
-			<button type="submit" id="applybutton" value="Apply" class="btn btn-primary">
-			{% trans "Apply" %}</button>
-		</div>
+	<div class="col-md-6">
+		<form method="POST" class="" id="catenroll_form" action="{% url catenroll %}">
+		{% csrf_token %}
+			<div class="form-group">
+				<label class="control-label" for="id_catinstance"><b>{% trans "CAT instance" %}</b></label>
+				<div class="controls">
+					<select id="catinstance" name="catinstance">
+						{% for instance in cat_instances %}
+							<option value="{{instance.0}}">{{instance.1}}</option>
+						{% endfor %}
+					</select>
+				</div>
+			</div>
+			<div class="control-group">
+				<div class="controls">
+					<button type="submit" id="applybutton" value="Apply" class="btn btn-primary">
+						{% trans "Apply" %}
+					</button>
+				</div>
+			</div>
+		</form>
 	</div>
-</form>
-</div></div>
+</div>
 {% endif %}
+
 {% if response_status %}
 <div class="row">
-<div class="span12">
-	<div class="alert {% if response_status == 'Error' %}alert-error{% else %}alert-success{% endif %}">
-	<div><strong>Status:</strong> {{response_status}}</div>
-	{% if not cat_url %}
-	<div><strong>Response:</strong> {{response}}</div>
-	{% else %}
-	<div><strong>Institution Id:</strong> {{inst_uid}}</div>
-	<div><strong>CAT url:</strong> <a href="{{cat_url}}" target="_blank">{{cat_url}}</a></div>
-	{% endif %}
+	<div class="col-md-12">
+		<div class="alert {% if response_status == 'Error' %}alert-error{% else %}alert-success{% endif %}">
+			<div><strong>{%  trans 'Status' %}:</strong> {{response_status}}</div>
+		{% if not cat_url %}
+			<div><strong>{% trans 'Response' %}:</strong> {{response}}</div>
+		{% else %}
+			<div><strong>{% trans 'Institution Id' %}:</strong> {{inst_uid}}</div>
+			<div><strong>{% trans 'CAT url' %}:</strong> <a href="{{cat_url}}" target="_blank">{{cat_url}}</a></div>
+		{% endif %}
+		</div>
 	</div>
 </div>
-</div>
 {% endif %}
 {% endblock %}
 